nxpix=1000L
nypix=1000L

SETPLOT='ps'
SETPLOT='Z'
;read,'setplot?',setplot

if setplot eq 'Z' then begin
;-------------------------------------------
set_plot,'Z'
device,set_resolution=[nxpix,nypix],z_buffer=0
win_nx=!d.x_size
win_ny=!d.y_size

;--------------------------------------------
; Insert the main script
;--------------------------------------------
endif
if SETPLOT eq 'ps' then set_plot,'ps'
; set color table
  loadct,38
  !p.background=254.
  !p.color=255.
mcolor=byte(!p.color)
mcolor=fix(mcolor)
if mcolor eq 0 then mcolor=255
col1=mcolor
icmm1=mcolor-1
icmm2=mcolor-2
if setplot eq 'x' then begin
   lc=mcolor
   window,4,xsize=nxdim,ysize=nydim
   device,retain=2,decomposed=0
endif
; Specify window size
nxdim=1000L
nydim=1000L
yyyymmdd='20180814'
!p.charsize=1
set_viewport,0,1,0,1
!type=2^5+2^6
plot,[0,1],[0,1],/nodata
polyfill,[0,1,1,0,0],[0,0,1,1,0],color=mcolor
;
curtain_dir='/ships19/aqda/bpierce/FIREX-AQ/FV3RAQMS_TROPOMI/Curtain/'
openr,1,'tropomi.co.fil.short'
nfiles=0l
readf,1,nfiles
for nf=0,nfiles-1 do begin
blank=''
readf,1,blank
;S5P_OFFL_L2__NO2____20180701T161259_20180701T175428_03707_01_010002_20180707T175356.nc
;S5P_OFFL_L2__CO_____20180814T172700_20180814T190829_04332_01_010100_20180820T164534.nc
result=str_sep(blank,'.')
sfile=result(0)
result=str_sep(blank,'_____')
syr=strmid(result(1),0,4)
smn=strmid(result(1),4,2)
sdy=strmid(result(1),6,2)
hrmnsc=strmid(result(1),9,6)
shr=strmid(hrmnsc,0,2)
smin=strmid(hrmnsc,2,2)
ssc=strmid(hrmnsc,4,2)
if nf eq 0 then shrs=shr+':'+smin+':'+ssc
if nf gt 0 then shrs=shrs+'Z +'+shr+':'+smin+':'+ssc
result=str_sep(blank,'.dat')
sfile=result(0)+'.tropomi.da.dat'
ofile0=curtain_dir+blank
ofile1=curtain_dir+sfile
print,blank
print,sfile
  openr,20,ofile0,/f77
nc0=0l
nr0=0l
nl0=0l
nl=0l
  readu,20,nc0,nr0
utcsec2d=fltarr(nc0,nr0)
xco=fltarr(nc0,nr0)
yco=fltarr(nc0,nr0)
cocolumn=fltarr(nc0,nr0)
  readu,20,utcsec2d
  readu,20,xco
  readu,20,yco
  readu,20,cocolumn
  readu,20,nl0,nc0,nr0
averaging_kernel=fltarr(nl0,nc0,nr0)
pressure=fltarr(nl0,nc0,nr0)
  readu,20,averaging_kernel
  readu,20,pressure
  readu,20,nl,nc0,nr0
pcurt=fltarr(nl,nc0,nr0)
zcurt=fltarr(nl,nc0,nr0)
dpcurt=fltarr(nl,nc0,nr0)
dzcurt=fltarr(nl,nc0,nr0)

curtain0=fltarr(nl,nc0,nr0)

  readu,20,pcurt
  readu,20,zcurt
  readu,20,dpcurt
  readu,20,dzcurt

  readu,20,curtain0
  close,20
  openr,20,ofile1,/f77
nc0=0l
nr0=0l
nl0=0l
nl=0l
  readu,20,nc0,nr0
utcsec2d=fltarr(nc0,nr0)
xco=fltarr(nc0,nr0)
yco=fltarr(nc0,nr0)
cocolumn=fltarr(nc0,nr0)
  readu,20,utcsec2d
  readu,20,xco
  readu,20,yco
  readu,20,cocolumn
  readu,20,nl0,nc0,nr0
averaging_kernel=fltarr(nl0,nc0,nr0)
pressure=fltarr(nl0,nc0,nr0)
  readu,20,averaging_kernel
  readu,20,pressure
  readu,20,nl,nc0,nr0
pcurt=fltarr(nl,nc0,nr0)
zcurt=fltarr(nl,nc0,nr0)
dpcurt=fltarr(nl,nc0,nr0)
dzcurt=fltarr(nl,nc0,nr0)

curtain1=fltarr(nl,nc0,nr0)

  readu,20,pcurt
  readu,20,zcurt
  readu,20,dpcurt
  readu,20,dzcurt

  readu,20,curtain1
  close,20

;  help,nc0,nr0
;  help,utcsec2d
;  help,xco
;  help,yco
;  help,cocolumn
;  help,nl0,nc0,nr0
;  help,averaging_kernel
;  help,nl,nc0,nr0
;  help,pcurt
;  help,curtain
    fac=1.0e4*6.023e23/28.97/9.8/1000.
;help,pcurt,curtain
cocol0_ak=fltarr(nc0,nr0)
cocol0=fltarr(nc0,nr0)
cocol1_ak=fltarr(nc0,nr0)
cocol1=fltarr(nc0,nr0)

for i=0,nc0-1 do begin
for j=0,nr0-1 do begin
;if curtain(0,i,j) gt 0.0 then begin
;plm1=.5*(pcurt(nl-1,i,j)+pcurt(nl-2,i,j))
;for llev=nl-3,0,-1 do begin
;pl=.5*(pcurt(llev+1,i,j)+pcurt(llev,i,j))
;dp=pl-plm1
;    cocol(i,j)=cocol(i,j)+dp*curtain(llev,i,j)*fac
;plm1=pl
;endfor
;dp=2.*(pcurt(0,i,j)-plm1)
;    cocol(i,j)=cocol(i,j)+dp*curtain(0,i,j)*fac
;endif
;if curtain(0,i,j) gt 0.0 and pressure(0,i,j) ne 9.96921e+34 and cocolumn(i,j) ne -999. then begin
if cocolumn(i,j) ne -999. then begin
;if curtain(0,i,j) gt 0.0 then begin
;
; interpolate model co profile and altitude to TROPOMI vertical grid
;
coint0=0.*findgen(nl0)
coint1=0.*findgen(nl0)
zint=0.*findgen(nl0)
dum0=reform(pressure(*,i,j),nl0)
dum1=reform(pcurt(*,i,j),nl)
index=where(dum0 ge min(dum1) and dum0 le max(dum1))
coint0(index)=interpol(curtain0(*,i,j),pcurt(*,i,j),pressure(index,i,j))
coint1(index)=interpol(curtain1(*,i,j),pcurt(*,i,j),pressure(index,i,j))

zint(index)=interpol(zcurt(*,i,j),pcurt(*,i,j),pressure(index,i,j))
plm1=.5*(pressure(nl0-1,i,j)+pressure(nl0-2,i,j))
zlm1=.5*(zint(nl0-1)+zint(nl0-2))
for llev=nl0-3,0,-1 do begin
pl=.5*(pressure(llev+1,i,j)+pressure(llev,i,j))
zl=.5*(zint(llev+1)+zint(llev))

dp=plm1-pl
dz=zl-zlm1
if dp gt 0.0 then    cocol0(i,j)=cocol0(i,j)+dp*coint0(llev)*fac
if dp gt 0.0 and dz gt 0.0 then    cocol0_ak(i,j)=cocol0_ak(i,j)+dp*coint0(llev)*averaging_kernel(llev,i,j)*fac/dz
if dp gt 0.0 then    cocol1(i,j)=cocol1(i,j)+dp*coint1(llev)*fac
if dp gt 0.0 and dz gt 0.0 then    cocol1_ak(i,j)=cocol1_ak(i,j)+dp*coint1(llev)*averaging_kernel(llev,i,j)*fac/dz

plm1=pl
zlm1=zl
endfor
dp=2.*(pressure(0,i,j)-plm1)
dz=2.*(zint(0)-zlm1)

if dp gt 0.0 then    cocol0(i,j)=cocol0(i,j)+dp*coint0(0)*fac
if dp gt 0.0 and dz gt 0.0 then    cocol0_ak(i,j)=cocol0_ak(i,j)+dp*coint0(0)*averaging_kernel(0,i,j)*fac/dz
if dp gt 0.0 then    cocol1(i,j)=cocol1(i,j)+dp*coint1(0)*fac
if dp gt 0.0 and dz gt 0.0 then    cocol1_ak(i,j)=cocol1_ak(i,j)+dp*coint1(0)*averaging_kernel(0,i,j)*fac/dz
;if cocol(i,j) gt 3.e18 then print,cocol(i,j),cocol_ak(i,j)

;
; in model space
;
;for llev=nl-1,0,-1 do begin
;dp=dpcurt(llev,i,j)
;dz=dzcurt(llev,i,j)
;    cocol(i,j)=cocol(i,j)+dp*curtain(llev,i,j)*fac
;    cocol_ak(i,j)=cocol_ak(i,j)+dp*curtain(llev,i,j)*ak(llev)*fac/dz
;endfor
endif
endfor
endfor
cocol0=1.e-18*cocol0
cocol0_ak=1.e-18*cocol0_ak
cocol1=1.e-18*cocol1
cocol1_ak=1.e-18*cocol1_ak
;
; save
;
index=where(cocol0 ne 0.0 and cocolumn ne -999.)
if nf eq 0 then begin
cocol0_sav=cocol0(index)
cocol1_sav=cocol1(index)
cocol0_ak_sav=cocol0_ak(index)
cocol1_ak_sav=cocol1_ak(index)
cocolumn_sav=cocolumn(index)
lon_sav=xco(index)
lat_sav=yco(index)
endif
if nf gt 0 then begin
cocol0_sav=[cocol0_sav,cocol0(index)]
cocol1_sav=[cocol1_sav,cocol1(index)]
cocol0_ak_sav=[cocol0_ak_sav,cocol0_ak(index)]
cocol1_ak_sav=[cocol1_ak_sav,cocol1_ak(index)]
cocolumn_sav=[cocolumn_sav,cocolumn(index)]
lon_sav=[lon_sav,xco(index)]
lat_sav=[lat_sav,yco(index)]
endif
endfor
erase
!p.charsize=1
set_viewport,0,1,0,1
!type=2^5+2^6
plot,[0,1],[0,1],/nodata
polyfill,[0,1,1,0,0],[0,0,1,1,0],color=mcolor
!type=2^2+2^3
set_viewport,.1,.9,.2,.9
plot,[0,6],[0,6],/nodata,color=0B,$
xtitle='TropOMI CO (1e18 mol/cm!u2!n)',$
ytitle='FV3GFS/RAQMS_AK CO (1e18 mol/cm!u2!n)',$
title='FV3GFS/RAQMS_AK vs TropOMI CO '+syr+smn+sdy+'!C(red=TROPOMI DA, black=No DA)'
!psym=3
oplot,cocolumn_sav,cocol0_ak_sav,color=0B
oplot,cocolumn_sav,cocol1_ak_sav,color=icmm2
!psym=0
result0=correlate(COCOLUMN_SAV,COCOL0_AK_SAV)
result1=correlate(COCOLUMN_SAV,COCOL1_AK_SAV)
xyouts,.25,5.75,'(no DA)      r='+string(result0),color=0B
xyouts,.25,5.625,'(TropOMI DA) r='+string(result1),color=icmm2
;     0.583757     0.693794
result0=total(COCOLUMN_SAV-COCOL0_AK_SAV)/(1.*n_elements(COCOLUMN_SAV))
result1=total(COCOLUMN_SAV-COCOL1_AK_SAV)/(1.*n_elements(COCOLUMN_SAV))
xyouts,.25,5.5,'(no DA)      bias='+string(result0)+' (obs-mod, 1e18 mol/cm!u2!n)',color=0B
xyouts,.25,5.375,'(TropOMI DA) bias='+string(result1)+' (obs-mod, 1e18 mol/cm!u2!n)',color=icmm2
;     0.136454     0.195382
result1=sqrt(total((COCOLUMN_SAV-COCOL1_AK_SAV)^2)/(1.*n_elements(COCOLUMN_SAV)))
result0=sqrt(total((COCOLUMN_SAV-COCOL0_AK_SAV)^2)/(1.*n_elements(COCOLUMN_SAV)))
xyouts,.25,5.25,'(no DA)      rms='+string(result0)+' (obs-mod, 1e18 mol/cm!u2!n)',color=0B
xyouts,.25,5.125,'(TropOMI DA) rms='+string(result1)+' (obs-mod, 1e18 mol/cm!u2!n)',color=icmm2
;     0.461984     0.440225
!p.thick=4
oplot,[0,6],[0,6],color=icmm2/2.
if setplot eq 'Z' then begin
image=tvrd(0,0,win_nx,win_ny)
image_byt=bytscl(image,min=0,max=255)
;transparent=bytarr(256)+255B
;transparent(255:255)=0
tvlct,r,g,b,/get
;write_png,'FV3RAQMS.CO.scale.aware.sas.flux.limited.'+syr+smn+sdy+'.big.png',image_byt,r,g,b
;write_png,'FV3GFS.RAQMS.CO.'+syr+smn+sdy+'.big.model.png',image_byt,r,g,b
write_png,'TROPOMI.vs.FV3GFS.RAQMS.CO.'+syr+smn+sdy+'.AK.scatter.png',image_byt,r,g,b
endif
end
